#include "include/snake.h"

/* extern data */
extern int delay;
extern int typein;
extern snake *zoo[];
extern WINDOW *pausewin;

/* private functions */
void pause(void);

/* parse user input */
int parse_input ()
{
	/* get a character */
	typein=getch();

	switch (typein)
	{
		/* return 0 when reading the quit command */
		case 'q':
			return 0;

		/* lower delay if '-' */
		case '-':
			delay += delay/2+1;
			if ( delay > 500 ) delay = 500;
			break;

		/* higher delay if '+'  */
		case '=':
		case '+':
			delay -= delay/2;
			if ( delay < 1 ) delay = 1;
			break;

		/* pause game */
		case 'p':
			pause();
			break;


		/* nothing to do by default */
		default:
			break;
	}

	return 1;
}


void pause()
{
	touchwin(pausewin);
	wrefresh(pausewin);
	for(;;)
	{
		if ( getch() != ERR ) break;
	}
	touchwin(arenawin);
}
